###################################################
### chunk number 1: 
###################################################
#line 27 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
options(digits=3)
library(dlm)
set.seed(1963)


###################################################
### chunk number 2: 
###################################################
#line 78 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
dlm(FF = 1, V = 0.8, GG = 1, W = 0.1, m0 = 0, C0 = 100)


###################################################
### chunk number 3: 
###################################################
#line 86 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
dlmModPoly(order = 1, dV = 0.8, dW = 0.1, C0 = 100)


###################################################
### chunk number 4: 
###################################################
#line 101 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
myMod <- dlmModPoly()


###################################################
### chunk number 5: 
###################################################
#line 109 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
FF(myMod)
W(myMod)
m0(myMod)
V(myMod) <- 0.8


###################################################
### chunk number 6: 
###################################################
#line 194 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
myMod <- dlmModPoly() + dlmModSeas(4)


###################################################
### chunk number 7: 
###################################################
#line 251 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
dlmModPoly(dV = 0.2, dW = c(0, 0.5)) %+% 
    (dlmModSeas(4, dV = 0, dW = c(0, 0, 0.35)) + 
     dlmModPoly(1, dV = 0.1, dW = 0.03))


###################################################
### chunk number 8: 
###################################################
#line 287 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
u <- rnorm(25)
myMod <- dlmModReg(u, dV = 14.5)
myMod$JFF
head(myMod$X)


###################################################
### chunk number 9: 
###################################################
#line 312 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
buildFun <- function(x) {
    dlmModPoly(1, dV = exp(x[1]), dW = exp(x[2]))
}


###################################################
### chunk number 10: 
###################################################
#line 321 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
fit <- dlmMLE(Nile, parm = c(0,0), build = buildFun)
fit$conv
dlmNile <- buildFun(fit$par)
V(dlmNile)
W(dlmNile)


###################################################
### chunk number 11: 
###################################################
#line 331 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
StructTS(Nile, "level")


###################################################
### chunk number 12: 
###################################################
#line 340 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
buildFun <- function(x) {
    m <- dlmModPoly(1, dV = exp(x[1]))
    m$JW <- matrix(1)
    m$X <- matrix(exp(x[2]), nc = 1, nr = length(Nile))
    j <- which(time(Nile) == 1899)
    m$X[j,1] <- m$X[j,1] * (1 + exp(x[3]))
    return(m)
}
fit <- dlmMLE(Nile, parm = c(0,0,0), build = buildFun)
fit$conv
dlmNileJump <- buildFun(fit$par)
V(dlmNileJump)
dlmNileJump$X[c(1, which(time(Nile) == 1899)), 1]


###################################################
### chunk number 13: figFilter
###################################################
#line 397 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
nileJumpFilt <- dlmFilter(Nile, dlmNileJump)
plot(Nile, type = 'o', col = "seagreen")
lines(dropFirst(nileJumpFilt$m), type = 'o', 
      pch = 20, col = "brown")


###################################################
### chunk number 14: 
###################################################
#line 406 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
#line 397 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw#from line#406#"
nileJumpFilt <- dlmFilter(Nile, dlmNileJump)
plot(Nile, type = 'o', col = "seagreen")
lines(dropFirst(nileJumpFilt$m), type = 'o', 
      pch = 20, col = "brown")
#line 407 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
attach(nileJumpFilt)
v <- unlist(dlmSvd2var(U.C, D.C))
pl <- dropFirst(m) + qnorm(0.05, sd = sqrt(v[-1]))
pu <- dropFirst(m) + qnorm(0.95, sd = sqrt(v[-1]))
detach()
lines(pl, lty = 2, col = "brown") 
lines(pu, lty = 2, col = "brown") 


###################################################
### chunk number 15: 
###################################################
#line 434 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
attach(nileJumpFilt)
v <- unlist(dlmSvd2var(U.C, D.C))
pl <- dropFirst(m) + qnorm(0.05, sd = sqrt(v[-1]))
pu <- dropFirst(m) + qnorm(0.95, sd = sqrt(v[-1]))
detach()
lines(pl, lty = 2, col = "brown") 
lines(pu, lty = 2, col = "brown") 


###################################################
### chunk number 16: figSmooth
###################################################
#line 458 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
nileJumpSmooth <- dlmSmooth(nileJumpFilt)
plot(Nile, type = 'o', col = "seagreen")
attach(nileJumpSmooth)
lines(dropFirst(s), type = 'o', pch = 20, col = "brown")
v <- unlist(dlmSvd2var(U.S, D.S))
pl <- dropFirst(s) + qnorm(0.05, sd = sqrt(v[-1]))
pu <- dropFirst(s) + qnorm(0.95, sd = sqrt(v[-1]))
detach()
lines(pl, lty = 2, col = "brown") 
lines(pu, lty = 2, col = "brown") 


###################################################
### chunk number 17: 
###################################################
#line 473 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
#line 458 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw#from line#473#"
nileJumpSmooth <- dlmSmooth(nileJumpFilt)
plot(Nile, type = 'o', col = "seagreen")
attach(nileJumpSmooth)
lines(dropFirst(s), type = 'o', pch = 20, col = "brown")
v <- unlist(dlmSvd2var(U.S, D.S))
pl <- dropFirst(s) + qnorm(0.05, sd = sqrt(v[-1]))
pu <- dropFirst(s) + qnorm(0.95, sd = sqrt(v[-1]))
detach()
lines(pl, lty = 2, col = "brown") 
lines(pu, lty = 2, col = "brown") 
#line 474 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"


###################################################
### chunk number 18: 
###################################################
#line 485 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
lGas <- log(UKgas)
dlmGas <- dlmModPoly() + dlmModSeas(4)
buildFun <- function(x) {
    diag(W(dlmGas))[2:3] <- exp(x[1:2])
    V(dlmGas) <- exp(x[3])
    return(dlmGas)
}
(fit <- dlmMLE(lGas, parm = rep(0, 3), build = buildFun))$conv
dlmGas <- buildFun(fit$par)
drop(V(dlmGas))
diag(W(dlmGas))[2:3]


###################################################
### chunk number 19: 
###################################################
#line 503 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
gasSmooth <- dlmSmooth(lGas, mod = dlmGas)
x <- cbind(lGas, dropFirst(gasSmooth$s[,c(1,3)]))
colnames(x) <- c("Gas", "Trend", "Seasonal")
plot(x, type = 'o', main = "UK Gas Consumption")


###################################################
### chunk number 20: 
###################################################
#line 512 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
plot(x, type = 'o', main = "UK Gas Consumption")


###################################################
### chunk number 21: 
###################################################
#line 525 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
gasFilt <- dlmFilter(lGas, mod = dlmGas)
gasFore <- dlmForecast(gasFilt, nAhead = 20)
sqrtR <- sapply(gasFore$R, function(x) sqrt(x[1,1]))
pl <- gasFore$a[,1] + qnorm(0.05, sd = sqrtR)
pu <- gasFore$a[,1] + qnorm(0.95, sd = sqrtR)
x <- ts.union(window(lGas, start = c(1982, 1)), 
              window(gasSmooth$s[,1], start = c(1982, 1)),
              gasFore$a[,1], pl, pu) 
plot(x, plot.type = "single", type = 'o', pch = c(1, 0, 20, 3, 3),
     col = c("darkgrey", "darkgrey", "brown", "yellow", "yellow"),
     ylab = "Log gas consumption")
legend("bottomright", legend = c("Observed", 
                      "Smoothed (deseasonalized)", 
                      "Forecasted level", "90% probability limit"),
       bty = 'n', pch = c(1, 0, 20, 3, 3), lty = 1,
       col = c("darkgrey", "darkgrey", "brown", "yellow", "yellow"))


###################################################
### chunk number 22: 
###################################################
#line 546 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
plot(x, plot.type = "single", type = 'o', pch = c(1, 0, 20, 3, 3),
     col = c("darkgrey", "darkgrey", "brown", "yellow", "yellow"),
     ylab = "Log gas consumption")
legend("bottomright", legend = c("Observed", 
                      "Smoothed (deseasonalized)", 
                      "Forecasted level", "90% probability limit"),
       bty = 'n', pch = c(1, 0, 20, 3, 3), lty = 1,
       col = c("darkgrey", "darkgrey", "brown", "yellow", "yellow"))


###################################################
### chunk number 23: 
###################################################
#line 619 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
plot(Nile, type = 'o', col = "seagreen")
nileFilt <- dlmFilter(Nile, dlmNile)
for (i in 1:10) # 10 simulated "true" levels 
    lines(dropFirst(dlmBSample(nileFilt)), col = "brown") 


###################################################
### chunk number 24: 
###################################################
#line 627 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
plot(Nile, type = 'o', col = "seagreen")
for (i in 1:10) # 10 simulated "true" levels 
    lines(dropFirst(dlmBSample(nileFilt)), col = "brown") 


###################################################
### chunk number 25: 
###################################################
#line 659 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
lmixnorm <- function(x, weights, means, sds) {
    log(crossprod(weights, exp(-0.5 * ((x - means) / sds)^2 
                               - log(sds))))
}


###################################################
### chunk number 26: 
###################################################
#line 670 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
y <- arms(0, myldens = lmixnorm, 
          indFunc = function(x,...) (x > (-100)) * (x < 100), 
          n = 5000, weights = c(1, 3, 2), 
          means = c(-10, 0, 10), sds = c(7, 5, 2))
summary(y)
library(MASS)
truehist(y, prob = TRUE, ylim = c(0, 0.08), bty = 'o')
curve(colSums(c(1, 3, 2) / 6 *
              dnorm(matrix(x, 3, length(x), TRUE), 
                    mean = c(-10, 0, 10), sd = c(7, 5, 2))), 
      add = TRUE)
legend(-25, 0.07, "True density", lty = 1, bty = 'n')


###################################################
### chunk number 27: 
###################################################
#line 686 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
truehist(y, prob = TRUE, ylim = c(0, 0.08), bty = 'o')
curve(colSums(c(1, 3, 2) / 6 *
              dnorm(matrix(x, 3, length(x), TRUE), 
                    mean = c(-10, 0, 10), sd = c(7, 5, 2))), add = TRUE)
legend(-25, 0.07, "True density", lty = 1, bty = 'n')


###################################################
### chunk number 28: 
###################################################
#line 769 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
outGibbs <- dlmGibbsDIG(lGas, dlmModPoly(2) + dlmModSeas(4),
                        a.y = 1, b.y = 1000, a.theta = 1, 
                        b.theta = 1000,
                        n.sample = 1100, ind = c(2, 3),
                        save.states = FALSE)


###################################################
### chunk number 29: 
###################################################
#line 779 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
burn <- 100
attach(outGibbs)
par(mfrow=c(2,3), mar=c(3.1,2.1,2.1,1.1))
plot(dV[-(1:burn)], type = 'l', xlab="", ylab="", main=expression(sigma^2))
plot(dW[-(1:burn),1], type = 'l', xlab="", ylab="", main=expression(sigma[beta]^2))
plot(dW[-(1:burn),2], type = 'l', xlab="", ylab="", main=expression(sigma[s]^2))
use <- length(dV) - burn
from <- 0.05 * use
at <- pretty(c(0,use),n=3); at <- at[at>=from]
plot(ergMean(dV[-(1:burn)], from), type="l", xaxt="n",xlab="", ylab="")
axis(1, at=at-from, labels=format(at))
plot(ergMean(dW[-(1:burn),1], from), type="l", xaxt="n",xlab="", ylab="")
axis(1, at=at-from, labels=format(at))
plot(ergMean(dW[-(1:burn),2], from), type="l", xaxt="n",xlab="", ylab="")
axis(1, at=at-from, labels=format(at))
detach()


###################################################
### chunk number 30: 
###################################################
#line 806 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
burn <- 100
attach(outGibbs)
dV <- dV[-(1:burn)]
dW <- dW[-(1:burn), ]
detach()
par(mfrow=c(2,3), mar=c(3.1,2.1,2.1,1.1))
plot(dV, type = 'l', xlab = "", ylab = "", 
     main = expression(sigma^2))
plot(dW[ , 1], type = 'l', xlab = "", ylab = "", 
     main = expression(sigma[beta]^2))
plot(dW[ , 2], type = 'l', xlab = "", ylab = "", 
     main = expression(sigma[s]^2))
use <- length(dV) - burn
from <- 0.05 * use
at <- pretty(c(0, use), n = 3); at <- at[at >= from]
plot(ergMean(dV, from), type = 'l', xaxt = 'n',
     xlab = "", ylab = "")
axis(1, at = at - from, labels = format(at))
plot(ergMean(dW[ , 1], from), type = 'l', xaxt = 'n',
     xlab = "", ylab = "")
axis(1, at = at - from, labels = format(at))
plot(ergMean(dW[ , 2], from), type = 'l', xaxt = 'n',
     xlab = "", ylab = "")
axis(1, at =  at - from, labels = format(at))


###################################################
### chunk number 31: 
###################################################
#line 837 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
mcmcMean(cbind(dV[-(1:burn)], dW[-(1:burn), ]))


###################################################
### chunk number 32: 
###################################################
#line 840 "d:/Rcompile/CRANpkg/local/2.12/dlm/inst/doc/dlm.Rnw"
rm(dV, dW)


